# TODO:
# - resolve limit of interface traffic:
#   http://bugs.gentoo.org/attachment.cgi?id=80309&action=view
# - check which of these patches can be applied:
#   http://www.christoph-probst.com/technik/software/watchdog/5.2.4/
# - separate package with init-script for wd_keepalive - some parts should
#   be in -common subpackage.
#
# Conditional build
%bcond_without	systemd		# systemd unit

Summary:	A software watchdog
Summary(pl.UTF-8):	Programowy strażnik
Name:		watchdog
Version:	5.16
Release:	2
License:	GPL
Group:		Daemons
Source0:	http://ftp.debian.org/debian/pool/main/w/watchdog/%{name}_%{version}.orig.tar.gz
# Source0-md5:	1b4f51cabc64d1bee2fce7cdd626831f
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.service
Patch0:		%{name}-foreground.patch
Patch1:		%{name}-config.patch
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	rpmbuild(macros) >= 1.268
Requires(post,preun):	/sbin/chkconfig
%{?with_systemd:Requires(post,preun,postun):	systemd-units >= 1:250.1}
Requires:	rc-scripts
%{?with_systemd:Requires:	systemd-units >= 1:250.1}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The watchdog program writes to /dev/watchdog every ten seconds. If the
device is open but not written to within a minute the machine will
reboot. Each write delays the reboot time another minute. The ability
to reboot will depend on the state of the machines and interrupts.

%description -l pl.UTF-8
Program watchdog zapisuje do /dev/watchdog co 10 sekund. Jeżeli
urządzenie jest otwarte, ale nic nie zostanie zapisane przez minutę,
maszyna się zrebootuje. Każdy zapis opóźnia reboot o minutę. Możliwość
rebootu zależy od stanu maszyny i przerwań.

%prep
%setup -q
#%%patch -P0 -p1
%patch -P1 -p1

%build
%{__aclocal}
%{__autoconf}
%{__automake}
%configure
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{rc.d/init.d,sysconfig} %{?with_systemd:$RPM_BUILD_ROOT%{systemdunitdir}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/watchdog
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/watchdog
%{?with_systemd:install %{SOURCE3} $RPM_BUILD_ROOT%{systemdunitdir}/watchdog.service}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add watchdog
%{?with_systemd:%systemd_post watchdog.service}
%service watchdog restart "watchdog daemon"

%preun
if [ "$1" = 0 ] ; then
	%service watchdog stop
	/sbin/chkconfig --del watchdog
fi
%{?with_systemd:%systemd_preun watchdog.service}

%postun
%{?with_systemd:%systemd_reload}

%files
%defattr(644,root,root,755)
%doc ChangeLog README NEWS AUTHORS IAFA-PACKAGE TODO examples
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/watchdog.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/watchdog
%attr(754,root,root) /etc/rc.d/init.d/watchdog
%attr(755,root,root) %{_sbindir}/*
%{?with_systemd:%{systemdunitdir}/watchdog.service}
%{_mandir}/man?/*
%changelog
* Tue May 20 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/watchdog.git;a=log;h=master

* Thu May 01 2025 Jan Palus <atler@pld-linux.org> f05ff07
- add systemd unit; rel 2

* Fri Apr 25 2025 Jan Palus <atler@pld-linux.org> 81435d1
- use %patch -P

* Sat Nov 07 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> a4c331d
- up to 5.16

* Tue Feb 11 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 91c3be8
- use http://ftp.debian.org/ url

* Tue May 17 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> af51077
- up to 5.15; drop patch enabling defaults that are compiled into binary

* Thu Oct 23 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 8277a97
- up to 5.14

* Sat Feb 02 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 4e28cba
- up to 5.13

* Sun May 27 2012 blekot <blekot@pld-linux.org> 1d7a5c6
- updated to 5.12

* Sat Dec 31 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 9c2ec5d
- up to 5.11

* Mon Feb 07 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> d661441
- use oom_score_adj

* Sat Jan 29 2011 sparky <sparky@pld-linux.org> b38e6c6
- dropped pre-cvs changelog

* Sun Dec 19 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 2a22c4e
- up to 5.9

* Sat May 22 2010 Tomasz Pala <gotar@pld-linux.org> 66eb295
- fixed Group

* Fri Apr 23 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 07793d1
- up to 5.8

* Tue Aug 25 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> f4407f8
- rel 3; fixes from debian added

* Sun Jun 28 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 6825535
- rel 2; preload ipmi_si/ipmi_devintf when using ipmi_watchdog

* Sat May 30 2009 amateja <amateja@pld-linux.org> 5784943
- updated to 5.6

* Sat May 30 2009 amateja <amateja@pld-linux.org> 123f3b3
- adjusted for 5.6

* Sat Feb 28 2009 duddits <duddits@pld-linux.org> 1d23a2d
- up to 5.5

* Wed Jan 21 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> c5d05d0
- don't allow to be killed by OOM

